Index: /trunk/user/transpose/transpose.c
===================================================================
--- /trunk/user/transpose/transpose.c	(revision 656)
+++ /trunk/user/transpose/transpose.c	(revision 657)
@@ -15,16 +15,12 @@
 // A core is identified by two indexes [cxy,lid] : cxy is the cluster identifier,
 // (that is NOT required to be a continuous index), and lid is the local core index,
-// (that must be in the [Ø,NCORES-1] range).
+// (that must be in the [0,NCORES-1] range).
 //
 // The main() function can run on any core in any cluster. This main thread
-// makes the initialisations, uses the pthread_create() syscall to launch (NTHREADS-1)
-// other threads in "attached" mode running in parallel the execute() function, calls 
-// himself the execute() function, wait completion of the (NTHREADS-1) other threads 
-// with a pthread_join(), and finally calls the instrument() function to display
-// and register the instrumentation results when execution is completed.
-// All threads run the execute() function, but each thread transposes only
-// (NLINES / NTHREADS) lines. This requires that NLINES == k * NTHREADS.
+// makes the initialisations, load the input file to the "image_in" buffer,
+// launches the working threads, calls the instrument() function when all working
+// threads complete, and saves the result "image_out" buffer to the output file.
 //
-// The number N of working threads is always defined by the number of cores availables
+// The number of working threads is always defined by the number of cores availables
 // in the architecture, but this application supports three placement modes.
 // In all modes, the working threads are identified by the [tid] continuous index 
@@ -51,11 +47,12 @@
 //   per core, and the same relation between the thread[tid] and the core[cxy][lpid].
 //    
-// The buf_in[x,y] and buf_out[put buffers containing the direct and transposed images
-// are distributed in clusters: each thread[cid][0] allocate a local input buffer
-// and load in this buffer all lines that must be handled by the threads sharing the
-// same cid, from the mapper of the input image file.
-// In the execute function, all threads in the group defined by the cid index read pixels
-// from the local buf_in[cid] buffer, and write pixels to all remote buf_out[cid] buffers.
-// Finally, each thread displays a part of the transposed image to the frame buffer.
+// Each working thread[cid][lid] run the "execute" function, that uses the "buf_in" and
+// "buf_out" local buffers, containing the direct and transposed images:
+// Each thread[cid][0] allocates two buf_in[cid] and buf_out[cid] buffers, load from
+// "image_in" to buf_in[cid] all lines that must be handled by the threads sharing the
+// same cid, and finally save from buf_out[cid] to "image_out" all lines that have been
+// transposed to buf_out[cid]. 
+// Each thread[cid][lid] in the group defined by the cid index read pixels from the 
+// local buf_in[cid] buffer, and write pixels to all remote // buf_out[cid] buffers.
 //
 // - The image  must fit the frame buffer size, that must be power of 2.
@@ -82,19 +79,32 @@
 #define THREADS_MAX           (X_MAX * Y_MAX * CORES_MAX)  // max number of threads
 
-#define IMAGE_SIZE            512                          // image size 
 #define IMAGE_TYPE            420                          // pixel encoding type
-#define INPUT_FILE_PATH       "/misc/couple_512.raw"       // input file pathname 
-#define OUTPUT_FILE_PATH      "/misc/transposed_512.raw"   // output file pathname 
+
+//#define IMAGE_SIZE            128                          // image size 
+//#define INPUT_FILE_PATH       "/misc/images_128.raw"       // input file pathname 
+//#define OUTPUT_FILE_PATH      "/misc/transposed_128.raw"   // output file pathname 
+
+//#define IMAGE_SIZE            256                          // image size 
+//#define INPUT_FILE_PATH       "/misc/lena_256.raw"         // input file pathname 
+#//define OUTPUT_FILE_PATH      "/misc/transposed_256.raw"   // output file pathname 
+
+//#define IMAGE_SIZE            512                          // image size 
+//#define INPUT_FILE_PATH       "/misc/couple_512.raw"       // input file pathname 
+//#define OUTPUT_FILE_PATH      "/misc/transposed_512.raw"   // output file pathname 
+
+#define IMAGE_SIZE            1024                         // image size 
+#define INPUT_FILE_PATH       "/misc/philips_1024.raw"     // input file pathname 
+#define OUTPUT_FILE_PATH      "/misc/transposed_1024.raw"  // output file pathname 
 
 #define SAVE_RESULT_FILE      0                            // save result image on disk
-#define USE_DQT_BARRIER       1                            // quad-tree barrier if non zero 
+#define USE_DQT_BARRIER       0                            // quad-tree barrier if non zero 
 
 #define NO_PLACEMENT          0                            // uncontrolefdthread placement
-#define EXPLICIT_PLACEMENT    0                            // explicit threads placement
-#define PARALLEL_PLACEMENT    1                            // parallel threads placement
-
-#define VERBOSE_MAIN          0                            // main function print comments
-#define VERBOSE_EXEC          0                            // exec function print comments
-#define VERBOSE_INSTRU        0                            // instru function print comments
+#define EXPLICIT_PLACEMENT    1                            // explicit threads placement
+#define PARALLEL_PLACEMENT    0                            // parallel threads placement
+
+#define VERBOSE_MAIN          1                            // main function print comments
+#define VERBOSE_MAIN_DETAILED 0                            // main function print comments
+#define VERBOSE_EXEC          1                            // exec function print comments
 
 
@@ -109,20 +119,28 @@
 // instrumentation counters for each thread in each cluster 
 // indexed by [cid][lid] : cluster continuous index / thread local index
+unsigned int ALOC_START[CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
+unsigned int ALOC_END  [CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
 unsigned int LOAD_START[CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
 unsigned int LOAD_END  [CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
 unsigned int TRSP_START[CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
 unsigned int TRSP_END  [CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
-unsigned int DISP_START[CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
-unsigned int DISP_END  [CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
-
-// pointer on buffer containing the input image, maped by the main to the input file
-unsigned char *  image_in;
-
-// pointer on buffer containing the output image, maped by the main to the output file
-unsigned char *  image_out;
-
-// arrays of pointers on distributed buffers indexed by [cid] : cluster continuous index
-unsigned char *  buf_in_ptr [CLUSTERS_MAX];
-unsigned char *  buf_out_ptr[CLUSTERS_MAX];
+unsigned int SAVE_START[CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
+unsigned int SAVE_END  [CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
+unsigned int FREE_START[CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
+unsigned int FREE_END  [CLUSTERS_MAX][CORES_MAX] = {{ 0 }};
+
+// buffer containing the input image, loaded by the main from input file
+unsigned char  image_in[IMAGE_SIZE * IMAGE_SIZE];
+
+// buffer containing the output image, saved by the main to output file
+unsigned char  image_out[IMAGE_SIZE * IMAGE_SIZE];
+
+// arrays of pointers on distributed buffers indexed by [cid] 
+unsigned char *  buf_in [CLUSTERS_MAX];
+unsigned char *  buf_out[CLUSTERS_MAX];
+
+// pointer and identifier for dynamically allocated FBF window 
+void   *  win_buf;
+int       wid;
 
 // synchronisation barrier (all working threads)
@@ -205,5 +223,5 @@
     }
         
-    // main thread get identifiers for core executing main
+    // get identifiers for core executing main
     unsigned int  cxy_main;
     unsigned int  lid_main;
@@ -214,5 +232,11 @@
     unsigned int nthreads  = nclusters * ncores;
 
-    // main thread get FBF size and type
+    if( nthreads > IMAGE_SIZE )
+    {
+        printf("\n[transpose error] number of threads larger than number of lines\n");
+        exit( 0 );
+    }
+
+    // get FBF size and type
     unsigned int   fbf_width;
     unsigned int   fbf_height;
@@ -220,5 +244,5 @@
     fbf_get_config( &fbf_width , &fbf_height , &fbf_type );
 
-    if( (fbf_width != IMAGE_SIZE) || (fbf_height != IMAGE_SIZE) || (fbf_type != IMAGE_TYPE) )
+    if( (fbf_width < IMAGE_SIZE) || (fbf_height < IMAGE_SIZE) || (fbf_type != IMAGE_TYPE) )
     {
         printf("\n[transpose error] image does not fit FBF size or type\n");
@@ -226,17 +250,12 @@
     }
 
-    if( nthreads > IMAGE_SIZE )
-    {
-        printf("\n[transpose error] number of threads larger than number of lines\n");
-        exit( 0 );
-    }
-
-    unsigned int npixels = IMAGE_SIZE * IMAGE_SIZE;
+    // define total number of pixels
+    int npixels = IMAGE_SIZE * IMAGE_SIZE;
 
     // define instrumentation file name
     if( NO_PLACEMENT )
     {
-        printf("\n[transpose] %d cluster(s) / %d core(s) / FBF[%d*%d] / PID %x / NO_PLACE\n",
-        nclusters, ncores, fbf_width, fbf_height, getpid() );
+        printf("\n[transpose] %d cluster(s) / %d core(s) / <%s> / PID %x / NO_PLACE\n",
+        nclusters, ncores, INPUT_FILE_PATH , getpid() );
 
         // build instrumentation file name
@@ -251,6 +270,6 @@
     if( EXPLICIT_PLACEMENT )
     {
-        printf("\n[transpose] %d cluster(s) / %d core(s) / FBF[%d*%d] / PID %x / EXPLICIT\n",
-        nclusters, ncores, fbf_width, fbf_height, getpid() );
+        printf("\n[transpose] %d cluster(s) / %d core(s) / <%s> / PID %x / EXPLICIT\n",
+        nclusters, ncores, INPUT_FILE_PATH , getpid() );
 
         // build instrumentation file name
@@ -265,6 +284,6 @@
     if( PARALLEL_PLACEMENT )
     {
-        printf("\n[transpose] %d cluster(s) / %d core(s) / FBF[%d*%d] / PID %x / PARALLEL\n",
-        nclusters, ncores, fbf_width, fbf_height, getpid() );
+        printf("\n[transpose] %d cluster(s) / %d core(s) / <%s> / PID %x / PARALLEL\n",
+        nclusters, ncores, INPUT_FILE_PATH , getpid() );
 
         // build instrumentation file name
@@ -277,10 +296,28 @@
     }
 
+    // open a window in FBF
+    wid = fbf_create_window( 0,             // l_zero
+                             0,             // p_zero
+                             IMAGE_SIZE,    // lines
+                             IMAGE_SIZE,    // pixels
+                             &win_buf );
+    if( wid < 0) 
+    {
+        printf("\n[transpose error] cannot open FBF window\n");
+        exit( 0 );
+    }
+
+#if  VERBOSE_MAIN
+printf("\n[transpose] main on core[%x,%d] created FBF window %d / buffer %x\n",
+cxy_main, lid_main, wid , win_buf );
+#endif
+
     // open instrumentation file
     snprintf( pathname , 64 , "/home/%s", filename );
     FILE * f = fopen( pathname , NULL );
+
     if ( f == NULL ) 
     { 
-        printf("\n[transpose error] cannot open instrumentation file %s\n", pathname );
+        printf("\n[transpose error] cannot open instru file %s\n", pathname );
         exit( 0 );
     }
@@ -312,9 +349,9 @@
 
 #if  VERBOSE_MAIN
-printf("\n[transpose] main on core[%x,%d] completes barrier initialisation\n",
+printf("\n[transpose] main on core[%x,%d] completed barrier initialisation\n",
 cxy_main, lid_main );
 #endif
 
-    // main thread open input file
+    // open input file
     int fd_in = open( INPUT_FILE_PATH , O_RDONLY , 0 ); 
 
@@ -329,33 +366,5 @@
 #endif
 
-    // main thread map image_in buffer to input image file
-    image_in = (unsigned char *)mmap( NULL,
-                                      npixels,
-                                      PROT_READ,
-                                      MAP_FILE | MAP_SHARED,
-                                      fd_in,
-                                      0 );     // offset 
-    if ( image_in == NULL ) 
-    { 
-        printf("\n[transpose error] main cannot map buffer to file %s\n", INPUT_FILE_PATH );
-        exit( 0 );
-    }
-
-#if  VERBOSE_MAIN
-printf("\n[transpose] main map buffer to file <%s>\n", INPUT_FILE_PATH );
-#endif
-
-    // main thread display input image on FBF
-    if( fbf_write( image_in, 
-                   npixels,
-                   0 ) )
-    {
-        printf("\n[transpose error] main cannot access FBF\n");
-        exit( 0 );
-    }
-
-#if SAVE_RESULT_IMAGE
-
-    // main thread open output file
+    // open output file
     int fd_out = open( OUTPUT_FILE_PATH , O_CREAT , 0 ); 
 
@@ -366,26 +375,14 @@
     }
 
+    // move input image to input buffer
+    if( read( fd_in , image_in , npixels ) != npixels )
+    {
+        printf("\n[transpose error] main cannot read input image\n");
+        exit( 0 );
+    }
+
 #if  VERBOSE_MAIN
-printf("\n[transpose] main open file <%s> / fd = %d\n", OUTPUT_FILE_PATH , fd_out );
-#endif
-
-    // main thread map image_out buffer to output image file
-    image_out = (unsigned char *)mmap( NULL,
-                                       npixels,
-                                       PROT_WRITE,
-                                       MAP_FILE | MAP_SHARED,
-                                       fd_out,
-                                       0 );     // offset 
-    if ( image_out == NULL ) 
-    { 
-        printf("\n[transpose error] main cannot map buf_out to file %s\n", OUTPUT_FILE_PATH );
-        exit( 0 );
-    }
-
-#if  VERBOSE_MAIN
-printf("\n[transpose] main map buffer to file <%s>\n", OUTPUT_FILE_PATH );
-#endif
-
-#endif  // SAVE_RESULT_IMAGE
+printf("\n[transpose] main moved file <%s> to buf_in\n", INPUT_FILE_PATH );
+#endif
 
     /////////////////////////////////////////////////////////////////////////////////////
@@ -417,5 +414,5 @@
                 }
 
-#if VERBOSE_MAIN
+#if VERBOSE_MAIN_DETAILED
 printf("\n[transpose] main created thread %d\n", tid );
 #endif
@@ -450,6 +447,6 @@
             }
 
-#if VERBOSE_MAIN 
-printf("\n[transpose] main successfully joined thread %x\n", tid );
+#if VERBOSE_MAIN_DETAILED
+printf("\n[transpose] main joined thread %x\n", tid );
 #endif
         
@@ -500,5 +497,6 @@
                             exit( 0 );
                         }
-#if VERBOSE_MAIN 
+
+#if VERBOSE_MAIN_DETAILED
 printf("\n[transpose] main created thread[%d] on core[%x,%d]\n", tid, cxy, l );
 #endif
@@ -536,6 +534,7 @@
                     exit( 0 );
                 }
-#if VERBOSE_MAIN 
-printf("\n[transpose] main joined thread %d on core[%x,%d]\n", tid , cxy , l );
+
+#if VERBOSE_MAIN_DETAILED
+printf("\n[transpose] main joined thread %d\n", tid );
 #endif
             }
@@ -567,19 +566,63 @@
     /////////////////////////////////////////////////////////////////////////////
 
-    // main thread register instrumentation results
+    // register instrumentation results
     instrument( f , filename );
 
-    // main thread close input file 
+#if VERBOSE_MAIN
+printf("\n[transpose] main completed instrumentation\n");
+#endif
+
+/*
+    printf("\n> ");
+    getchar();
+
+    // move window
+    if( fbf_move_window( wid , 100 , 100 ) )
+    {
+        printf("\n[transpose error] main cannot move FBF window\n");
+        exit( 0 );
+    }
+
+    printf("\n> ");
+    getchar();
+*/    
+    // save image_out to output file
+    if( write( fd_out , image_out , npixels ) != npixels )
+    {
+        printf("\n[transpose error] main cannot write output image\n");
+        exit( 0 );
+    }
+
+#if VERBOSE_MAIN
+printf("\n[transpose] main saved buf_out to output file\n");
+#endif
+
+    // close input file 
     close( fd_in );
 
-#if SAVE_RESULT_IMAGE
-
-    // main thread close output file 
+#if VERBOSE_MAIN
+printf("\n[transpose] main closed input file\n");
+#endif
+
+    // close output file 
     close( fd_out );
 
-#endif
-
-    // main close instrumentation file
+#if VERBOSE_MAIN
+printf("\n[transpose] main closed output file\n");
+#endif
+
+    // close instrumentation file
     fclose( f );
+
+#if VERBOSE_MAIN
+printf("\n[transpose] main closed instrumentation file\n");
+#endif
+
+    // delete FBF window 
+    if( fbf_delete_window( wid ) )
+    {
+        printf("\n[transpose error] main cannot delete FBF window\n");
+        exit( 0 );
+    }
 
     // main thread suicide
@@ -597,8 +640,10 @@
 {
     unsigned long long   date;
+    unsigned int         l;         // line index for loop
+    unsigned int         p;         // pixel index for loop
+    int                  error;
+
+    unsigned char      * wbuf = win_buf;
  
-    unsigned int l;                         // line index for loop
-    unsigned int p;                         // pixel index for loop
-
     pthread_parallel_work_args_t * args = (pthread_parallel_work_args_t *)arguments;
 
@@ -613,6 +658,6 @@
     // get thread abstract identifiers 
     unsigned int tid = args->tid;
-    unsigned int cid = tid / ncores;   
-    unsigned int lid = tid % ncores;
+    unsigned int cid = tid / ncores;    // abstract cluster index
+    unsigned int lid = tid % ncores;    // local thread index
 
 #if VERBOSE_EXEC
@@ -620,4 +665,7 @@
 unsigned int lpid;
 get_core_id( &cxy , &lpid );   // get core physical identifiers
+#endif
+
+#if VERBOSE_EXEC
 printf("\n[transpose] exec[%d] on core[%x,%d] enters parallel exec\n",
 tid , cxy , lpid );
@@ -625,28 +673,33 @@
 
     get_cycle( &date );
-    LOAD_START[cid][lid] = (unsigned int)date;
-
-    // build total number of pixels per image
+    ALOC_START[cid][lid] = (unsigned int)date;
+
+    // compute total number of pixels per image
     unsigned int npixels = IMAGE_SIZE * IMAGE_SIZE;      
 
-    // build total number of threads and clusters
+    // compute total number of threads and clusters
     unsigned int nclusters = x_size * y_size;
     unsigned int nthreads  = nclusters * ncores;
 
-    unsigned int buf_size = npixels / nclusters;     // number of bytes in buf_in & buf_out
-    unsigned int offset   = cid * buf_size;       // offset in file (bytes)
-
-    unsigned char  * buf_in = NULL;        // private pointer on local input buffer
-    unsigned char  * buf_out = NULL;       // private pointer on local output buffer
-
-    // Each thread[cid,0] allocate a local buffer buf_in, and register
-    // the base adress in the global variable buf_in_ptr[cid]
-    // this local buffer is shared by all threads with the same cid
+    // compute number of pixels per cid & per thread
+    unsigned int pixels_per_cid = npixels / nclusters;
+    unsigned int pixels_per_lid = pixels_per_cid / ncores;
+
+    // compute first and last line per thread
+    unsigned int lines_per_cid = pixels_per_cid / IMAGE_SIZE;
+    unsigned int lines_per_lid = pixels_per_lid / IMAGE_SIZE;
+
+    unsigned int line_first = (cid * lines_per_cid) + (lid * lines_per_lid);
+    unsigned int line_last  = line_first + lines_per_lid;
+
+    // Each thread[cid,0] allocates two local buffers, and register the base 
+    // adresses in the global variable buf_in_ptr[cid] & buf_out_ptr[cid].
+    
     if( lid == 0 )
     {
         // allocate buf_in
-        buf_in = (unsigned char *)malloc( buf_size );
-
-        if( buf_in == NULL )
+        buf_in[cid] = (unsigned char *)malloc( pixels_per_cid );
+
+        if( buf_in[cid] == NULL )
         {
             printf("\n[transpose error] thread[%d] cannot allocate buf_in\n", tid );
@@ -654,7 +707,4 @@
         }
 
-        // register buf_in buffer in global array of pointers
-        buf_in_ptr[cid] = buf_in;
-
 #if VERBOSE_EXEC
 printf("\n[transpose] exec[%d] on core[%x,%d] allocated buf_in = %x\n",
@@ -662,27 +712,8 @@
 #endif
 
-    }
-
-    // Each thread[cid,0] copy relevant part of the image_in to buf_in
-    if( lid == 0 )
-    {
-        memcpy( buf_in,
-                image_in + offset,
-                buf_size );
-    } 
-
-#if VERBOSE_EXEC
-printf("\n[transpose] exec[%d] on core[%x,%d] loaded buf_in[%d]\n",
-tid , cxy , lpid , cid );
-#endif
-
-    // Each thread[cid,0] allocate a local buffer buf_out, and register
-    // the base adress in the global variable buf_out_ptr[cid]
-    if( lid == 0 )
-    {
         // allocate buf_out
-        buf_out = (unsigned char *)malloc( buf_size );
-
-        if( buf_out == NULL )
+        buf_out[cid] = (unsigned char *)malloc( pixels_per_cid );
+
+        if( buf_out[cid] == NULL )
         {
             printf("\n[transpose error] thread[%d] cannot allocate buf_in\n", tid );
@@ -690,7 +721,4 @@
         }
 
-        // register buf_in buffer in global array of pointers
-        buf_out_ptr[cid] = buf_out;
-
 #if VERBOSE_EXEC
 printf("\n[transpose] exec[%d] on core[%x,%d] allocated buf_out = %x\n",
@@ -699,5 +727,44 @@
 
     }
-    
+
+    get_cycle( &date );
+    ALOC_END[cid][lid] = (unsigned int)date;
+
+    /////////////////////////////////
+    pthread_barrier_wait( &barrier );
+    /////////////////////////////////
+
+    get_cycle( &date );
+    LOAD_START[cid][lid] = (unsigned int)date;
+
+    // all threads copy relevant part of the image_in to buf_in[cid]
+    memcpy( buf_in[cid] + (lid * pixels_per_lid), 
+            image_in + (cid * pixels_per_cid) + (lid * pixels_per_lid),
+            pixels_per_lid );
+
+#if VERBOSE_EXEC
+printf("\n[transpose] exec[%d] on core[%x,%d] loaded buf_in[%d]\n",
+tid , cxy , lpid , cid );
+#endif
+
+    // all local threads copy part of buf_in[cid] to FBF window for display
+    memcpy( wbuf + (cid * pixels_per_cid) + (lid * pixels_per_lid),
+            buf_in[cid] + (lid * pixels_per_lid),
+            pixels_per_lid );
+
+#if  VERBOSE_EXEC
+printf("\n[transpose] exec[%d] on core[%x,%d] loaded buf_in to FBF (first %d / last %d)\n",
+tid , cxy , lpid , line_first , line_last );
+#endif
+
+    // retresh window
+    error = fbf_refresh_window( wid , line_first , line_last );
+
+    if( error )
+    {
+        printf("\n[transpose error] exec[%d] cannot refresh FBF window\n", tid );
+        exit( 0 );
+    }
+
     get_cycle( &date );
     LOAD_END[cid][lid] = (unsigned int)date;
@@ -705,17 +772,14 @@
     /////////////////////////////////
     pthread_barrier_wait( &barrier );
+    /////////////////////////////////
 
     get_cycle( &date );
     TRSP_START[cid][lid] = (unsigned int)date;
 
-    // All threads contribute to parallel transpose from buf_in to buf_out
+    // All threads contribute to parallel transpose from buf_in to buf_out:
     // each thread makes the transposition for nlt lines (nlt = npixels/nthreads)
     // from line [tid*nlt] to line [(tid + 1)*nlt - 1]
     // (p,l) are the absolute pixel coordinates in the source image
-    // (l,p) are the absolute pixel coordinates in the source image
-    // (p,l) are the absolute pixel coordinates in the dest image
-
-    get_cycle( &date );
-    TRSP_START[cid][lid] = (unsigned int)date;
+    // (l,p) are the absolute pixel coordinates in the dest image
 
     unsigned int nlt   = IMAGE_SIZE / nthreads;    // number of lines per thread
@@ -729,5 +793,5 @@
     unsigned char byte;
 
-    unsigned int first = tid * nlt;     // first line index for a given thread
+    unsigned int first = tid * nlt;        // first line index for a given thread
     unsigned int last  = first + nlt;      // last line index for a given thread
 
@@ -742,5 +806,5 @@
             src_index = (l % nlc) * IMAGE_SIZE + p;
 
-            byte        = buf_in_ptr[src_cid][src_index];
+            byte = buf_in[src_cid][src_index];
 
             // write one byte to remote buf_out
@@ -748,5 +812,5 @@
             dst_index = (p % nlc) * IMAGE_SIZE + l;
 
-            buf_out_ptr[dst_cid][dst_index] = byte;
+            buf_out[dst_cid][dst_index] = byte;
         }
     }
@@ -762,40 +826,32 @@
     /////////////////////////////////
     pthread_barrier_wait( &barrier );
+    /////////////////////////////////
 
     get_cycle( &date );
-    DISP_START[cid][lid] = (unsigned int)date;
-
-    // All threads contribute to parallel display 
-    // from local buf_out to frame buffer
-    unsigned int  npt   = npixels / nthreads;   // number of pixels per thread
-
-    if( fbf_write( &buf_out_ptr[cid][lid * npt], 
-                   npt,
-                   npt * tid ) )
-    {
-        printf("\n[transpose error] thread[%d] cannot access FBF\n", tid );
-        pthread_exit( &THREAD_EXIT_FAILURE );
-    }
-
-#if VERBOSE_EXEC
-printf("\n[transpose] exec[%d] on core [%x,%d] completes display\n",
-tid, cxy , lpid );
-#endif
-
-    get_cycle( &date );
-    DISP_END[cid][lid] = (unsigned int)date;
-
-    /////////////////////////////////
-    pthread_barrier_wait( &barrier );
-
-#if SAVE_RESULT_IMAGE
-
-    // Each thread[cid,0] copy buf_out to relevant part of image_out
-    if( lid == 0 )
-    {
-        memcpy( image_out + offset,
-                buf_out,
-                buf_size );
-    } 
+    SAVE_START[cid][lid] = (unsigned int)date;
+
+    // each local threads copy part of buf_out[cid] to FBF window for display
+    memcpy( wbuf + (cid * pixels_per_cid) + (lid * pixels_per_lid),
+            buf_out[cid] + (lid * pixels_per_lid),
+            pixels_per_lid );
+
+#if  VERBOSE_EXEC
+printf("\n[transpose] exec[%d] on core[%x,%d] loaded buf_out to FBF (first %d / last %d)\n",
+tid , cxy , lpid , line_first , line_last );
+#endif
+
+    // refresh window
+    error = fbf_refresh_window( wid , line_first , line_last );
+
+    if( error )
+    {
+        printf("\n[transpose error] exec[%d] cannot refresh FBF window\n", tid );
+        exit( 0 );
+    }
+
+    // each local thread copy relevant part of buf_out to image_out
+    memcpy( image_out + (cid * pixels_per_cid) + (lid * pixels_per_lid),
+            buf_out[cid] + (lid * pixels_per_lid),
+            pixels_per_lid );
 
 #if VERBOSE_EXEC
@@ -804,13 +860,35 @@
 #endif
 
-#endif
-
-    // Each thread[cid,0] releases local buffer buf_out
+    get_cycle( &date );
+    SAVE_END[cid][lid] = (unsigned int)date;
+
+    /////////////////////////////////
+    pthread_barrier_wait( &barrier );
+    /////////////////////////////////
+
+    get_cycle( &date );
+    FREE_START[cid][lid] = (unsigned int)date;
+
+    // Each thread[cid,0] release local buffers buf_in & buf_out
+
     if( lid == 0 )
     {
-        // release buf_out
-        free( buf_in );
-        free( buf_out );
-    }
+        // release local buffers
+        free( buf_in[cid] );
+        free( buf_out[cid] );
+
+#if VERBOSE_EXEC
+printf("\n[transpose] exec[%d] on core[%x,%d] released buf_in & buf_out\n",
+tid , cxy , lpid );
+#endif
+
+    }
+
+    get_cycle( &date );
+    FREE_END[cid][lid] = (unsigned int)date;
+
+    /////////////////////////////////
+    pthread_barrier_wait( &barrier );
+    /////////////////////////////////
     
     // thread termination depends on the placement policy
@@ -829,5 +907,13 @@
         // <work> threads are running in attached mode
         // each thread, but de main, simply exit
-        if ( tid != tid_main )  pthread_exit( &THREAD_EXIT_SUCCESS );
+        if ( tid != tid_main )  
+        {
+
+#if VERBOSE_EXEC
+printf("\n[transpose] exec[%d] on core[%x,%d] exit\n",
+tid , cxy , lpid );
+#endif
+            pthread_exit( &THREAD_EXIT_SUCCESS );
+        }
     }
 
@@ -838,14 +924,15 @@
 
 
-///////////////////////////
+//////////////////////////
 void instrument( FILE * f,
                  char * filename )
 {
-    unsigned int x, y, l;
-
-#if VERBOSE_EXEC
-printf("\n[transpose] main enters instrument\n" );
-#endif
-
+    unsigned int cid;
+    unsigned int l;
+
+    unsigned int min_aloc_start = 0xFFFFFFFF;
+    unsigned int max_aloc_start = 0;
+    unsigned int min_aloc_ended = 0xFFFFFFFF;
+    unsigned int max_aloc_ended = 0;
     unsigned int min_load_start = 0xFFFFFFFF;
     unsigned int max_load_start = 0;
@@ -856,30 +943,37 @@
     unsigned int min_trsp_ended = 0xFFFFFFFF;
     unsigned int max_trsp_ended = 0;
-    unsigned int min_disp_start = 0xFFFFFFFF;
-    unsigned int max_disp_start = 0;
-    unsigned int min_disp_ended = 0xFFFFFFFF;
-    unsigned int max_disp_ended = 0;
+    unsigned int min_save_start = 0xFFFFFFFF;
+    unsigned int max_save_start = 0;
+    unsigned int min_save_ended = 0xFFFFFFFF;
+    unsigned int max_save_ended = 0;
+    unsigned int min_free_start = 0xFFFFFFFF;
+    unsigned int max_free_start = 0;
+    unsigned int min_free_ended = 0xFFFFFFFF;
+    unsigned int max_free_ended = 0;
  
-    for (x = 0; x < x_size; x++)
-    {
-        for (y = 0; y < y_size; y++)
+    for (cid = 0; cid < (x_size * y_size) ; cid++)
+    {
+        for ( l = 0 ; l < ncores ; l++ )
         {
-            unsigned int cid = y_size * x + y;
-
-            for ( l = 0 ; l < ncores ; l++ )
-            {
-                if (LOAD_START[cid][l] < min_load_start)  min_load_start = LOAD_START[cid][l];
-                if (LOAD_START[cid][l] > max_load_start)  max_load_start = LOAD_START[cid][l];
-                if (LOAD_END[cid][l]   < min_load_ended)  min_load_ended = LOAD_END[cid][l]; 
-                if (LOAD_END[cid][l]   > max_load_ended)  max_load_ended = LOAD_END[cid][l];
-                if (TRSP_START[cid][l] < min_trsp_start)  min_trsp_start = TRSP_START[cid][l];
-                if (TRSP_START[cid][l] > max_trsp_start)  max_trsp_start = TRSP_START[cid][l];
-                if (TRSP_END[cid][l]   < min_trsp_ended)  min_trsp_ended = TRSP_END[cid][l];
-                if (TRSP_END[cid][l]   > max_trsp_ended)  max_trsp_ended = TRSP_END[cid][l];
-                if (DISP_START[cid][l] < min_disp_start)  min_disp_start = DISP_START[cid][l];
-                if (DISP_START[cid][l] > max_disp_start)  max_disp_start = DISP_START[cid][l];
-                if (DISP_END[cid][l]   < min_disp_ended)  min_disp_ended = DISP_END[cid][l];
-                if (DISP_END[cid][l]   > max_disp_ended)  max_disp_ended = DISP_END[cid][l];
-            }
+            if (ALOC_START[cid][l] < min_aloc_start)  min_aloc_start = ALOC_START[cid][l];
+            if (ALOC_START[cid][l] > max_aloc_start)  max_aloc_start = ALOC_START[cid][l];
+            if (ALOC_END[cid][l]   < min_aloc_ended)  min_aloc_ended = ALOC_END[cid][l]; 
+            if (ALOC_END[cid][l]   > max_aloc_ended)  max_aloc_ended = ALOC_END[cid][l];
+            if (LOAD_START[cid][l] < min_load_start)  min_load_start = LOAD_START[cid][l];
+            if (LOAD_START[cid][l] > max_load_start)  max_load_start = LOAD_START[cid][l];
+            if (LOAD_END[cid][l]   < min_load_ended)  min_load_ended = LOAD_END[cid][l]; 
+            if (LOAD_END[cid][l]   > max_load_ended)  max_load_ended = LOAD_END[cid][l];
+            if (TRSP_START[cid][l] < min_trsp_start)  min_trsp_start = TRSP_START[cid][l];
+            if (TRSP_START[cid][l] > max_trsp_start)  max_trsp_start = TRSP_START[cid][l];
+            if (TRSP_END[cid][l]   < min_trsp_ended)  min_trsp_ended = TRSP_END[cid][l];
+            if (TRSP_END[cid][l]   > max_trsp_ended)  max_trsp_ended = TRSP_END[cid][l];
+            if (SAVE_START[cid][l] < min_save_start)  min_save_start = SAVE_START[cid][l];
+            if (SAVE_START[cid][l] > max_save_start)  max_save_start = SAVE_START[cid][l];
+            if (SAVE_END[cid][l]   < min_save_ended)  min_save_ended = SAVE_END[cid][l];
+            if (SAVE_END[cid][l]   > max_save_ended)  max_save_ended = SAVE_END[cid][l];
+            if (FREE_START[cid][l] < min_free_start)  min_free_start = FREE_START[cid][l];
+            if (FREE_START[cid][l] > max_free_start)  max_free_start = FREE_START[cid][l];
+            if (FREE_END[cid][l]   < min_free_ended)  min_free_ended = FREE_END[cid][l];
+            if (FREE_END[cid][l]   > max_free_ended)  max_free_ended = FREE_END[cid][l];
         }
     }
